diff -ur mpd-5.6/src/link.c mpd-5.6-lutz/src/link.c
--- mpd-5.6/src/link.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/link.c	2013-04-24 12:07:27.000000000 +0200
@@ -157,14 +157,17 @@
 {
     char	name[NG_NODESIZ];
 
+    MUTEX_LOCK(gNgMutex);
     /* Create a netgraph socket node */
     snprintf(name, sizeof(name), "mpd%d-lso", gPid);
     if (NgMkSockNode(name, &gLinksCsock, &gLinksDsock) < 0) {
 	Perror("LinksInit(): can't create %s node", NG_SOCKET_NODE_TYPE);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
     (void) fcntl(gLinksCsock, F_SETFD, 1);
     (void) fcntl(gLinksDsock, F_SETFD, 1);
+    MUTEX_UNLOCK(gNgMutex);
 
     /* Listen for happenings on our node */
     EventRegister(&gLinksDataEvent, EVENT_READ,
@@ -463,7 +466,7 @@
         PhysInit(l);
         LcpInit(l);
 	
-	MsgRegister(&l->msgs, LinkMsg);
+	MsgSerialRegister(&l->msgs, LinkMsg);
 
 	/* Find a free link pointer */
         for (k = 0; k < gNumLinks && gLinks[k] != NULL; k++);
@@ -579,7 +582,7 @@
 void
 LinkShutdownCheck(Link l, short state)
 {
-    if (state == ST_INITIAL && l->lcp.auth.acct_thread == NULL &&
+    if (state == ST_INITIAL && l->lcp.auth.acct_msg == NULL &&
 	    l->die && !l->stay && l->state == PHYS_STATE_DOWN) {
 	REF(l);
 	MsgSend(&l->msgs, MSG_SHUTDOWN, l);
@@ -597,7 +600,7 @@
     struct linkaction	*a;
 
     Log(LG_LINK, ("[%s] Link: Shutdown", l->name));
-
+   
     /* Late divorce for DoD case */
     if (l->bund) {
 	l->bund->links[l->bundleIndex] = NULL;
@@ -636,6 +639,8 @@
 	Freee(l->downReason);
     MsgUnRegister(&l->msgs);
     UNREF(l);
+    
+   
     CheckOneShot();
 }
 
@@ -653,6 +658,7 @@
     struct ngm_mkpeer	mp;
     struct ngm_name	nm;
 
+    MUTEX_LOCK(gNgMutex);
     /* Initialize structures */
     memset(&mp, 0, sizeof(mp));
     memset(&nm, 0, sizeof(nm));
@@ -684,10 +690,12 @@
 	goto fail;
     };
 
+    MUTEX_UNLOCK(gNgMutex);
     /* OK */
     return(0);
 
 fail:
+    MUTEX_UNLOCK(gNgMutex);
     LinkNgShutdown(l);
     return(-1);
 }
@@ -702,6 +710,7 @@
     char		path[NG_PATHSIZ];
     struct ngm_connect	cn;
 
+    MUTEX_LOCK(gNgMutex);
     snprintf(path, sizeof(path), "[%lx]:", (u_long)l->nodeID);
 
     memset(&cn, 0, sizeof(cn));
@@ -713,10 +722,12 @@
       NGM_GENERIC_COOKIE, NGM_CONNECT, &cn, sizeof(cn)) < 0) {
 	Perror("[%s] can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\"",
 	    l->name, path, cn.ourhook, cn.path, cn.peerhook);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
     
     NgFuncDisconnect(gLinksCsock, l->name, path, NG_TEE_HOOK_LEFT2RIGHT);
+    MUTEX_UNLOCK(gNgMutex);
     return (0);
 }
 
@@ -730,6 +741,7 @@
     char		path[NG_PATHSIZ];
     struct ngm_connect	cn;
 
+    MUTEX_LOCK(gNgMutex);
     memset(&cn, 0, sizeof(cn));
     snprintf(cn.path, sizeof(cn.path), "[%lx]:", (u_long)l->nodeID);
     strcpy(cn.ourhook, l->hook);
@@ -738,11 +750,13 @@
       NGM_GENERIC_COOKIE, NGM_CONNECT, &cn, sizeof(cn)) < 0) {
 	Perror("[%s] can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\"",
 	    l->name, ".:", cn.ourhook, cn.path, cn.peerhook);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
     snprintf(path, sizeof(path), "[%lx]:", (u_long)l->nodeID);
     NgFuncDisconnect(gLinksCsock, l->name, path, NG_TEE_HOOK_RIGHT);
+    MUTEX_UNLOCK(gNgMutex);
     return (0);
 }
 
@@ -760,19 +774,22 @@
     snprintf(path, sizeof(path), "[%lx]:", (u_long)l->nodeID);
     strcpy(cn.ourhook, NG_TEE_HOOK_RIGHT);
     if (!PhysGetUpperHook(l, cn.path, cn.peerhook)) {
-        Log(LG_PHYS, ("[%s] Link: can't get repeater hook", l->name));
+        Log(LG_ERR|LG_PHYS, ("[%s] Link: can't get repeater hook", l->name));
         return (-1);
     }
+    MUTEX_LOCK(gNgMutex);
     if (NgSendMsg(gLinksCsock, path,
       NGM_GENERIC_COOKIE, NGM_CONNECT, &cn, sizeof(cn)) < 0) {
 	Perror("[%s] can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\"",
 	    l->name, path, cn.ourhook, cn.path, cn.peerhook);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
     /* Shutdown link tee node */
     NgFuncShutdownNode(gLinksCsock, l->name, path);
     l->hook[0] = 0;
+    MUTEX_UNLOCK(gNgMutex);
     return (0);
 }
 
@@ -783,9 +800,11 @@
 void
 LinkNgShutdown(Link l)
 {
+    MUTEX_LOCK(gNgMutex);
     if (l->hook[0])
 	NgFuncShutdownNode(gLinksCsock, l->name, l->hook);
     l->hook[0] = 0;
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
@@ -931,7 +950,9 @@
 	    if (naddr.sg_data[0] == 'o') {
 		IfaceCorrectMSS(bp, MAXMSS(b->iface.mtu));
 		naddr.sg_data[0] = 'i';
+		MUTEX_LOCK(gNgMutex);
 		NgFuncWriteFrame(gLinksDsock, naddr.sg_data, b->name, bp);
+		MUTEX_UNLOCK(gNgMutex);
 		continue;
 	    }
 
@@ -939,7 +960,9 @@
 	    if (naddr.sg_data[0] == 'i') {
 		IfaceCorrectMSS(bp, MAXMSS(b->iface.mtu));
 		naddr.sg_data[0] = 'o';
+		MUTEX_LOCK(gNgMutex);
 		NgFuncWriteFrame(gLinksDsock, naddr.sg_data, b->name, bp);
+		MUTEX_UNLOCK(gNgMutex);
 		continue;
 	    }
 #endif
@@ -1326,6 +1349,7 @@
 #ifndef NG_PPP_STATS64
     struct ng_ppp_link_stat	stats;
 
+    MUTEX_LOCK(gNgMutex);
     if (NgFuncGetStats(l->bund, l->bundleIndex, &stats) != -1) {
 	l->stats.xmitFrames += abs(stats.xmitFrames - l->oldStats.xmitFrames);
 	l->stats.xmitOctets += abs(stats.xmitOctets - l->oldStats.xmitOctets);
@@ -1336,11 +1360,15 @@
         l->stats.dupFragments += abs(stats.dupFragments - l->oldStats.dupFragments);
         l->stats.dropFragments += abs(stats.dropFragments - l->oldStats.dropFragments);
     }
+    MUTEX_UNLOCK(gNgMutex);
 
     l->oldStats = stats;
 #else
+    MUTEX_LOCK(gNgMutex);
     NgFuncGetStats64(l->bund, l->bundleIndex, &l->stats);
+    MUTEX_UNLOCK(gNgMutex);
 #endif
+   
 }
 
 /*
@@ -1350,12 +1378,14 @@
 void
 LinkResetStats(Link l)
 {
+    MUTEX_LOCK(gNgMutex);
     if (l->bund)
 	NgFuncClrStats(l->bund, l->bundleIndex);
     memset(&l->stats, 0, sizeof(l->stats));
 #ifndef NG_PPP_STATS64
     memset(&l->oldStats, 0, sizeof(l->oldStats));
 #endif
+    MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
diff -ur mpd-5.6/src/main.c mpd-5.6-lutz/src/main.c
--- mpd-5.6/src/main.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/main.c	2013-04-25 13:21:27.659354000 +0200
@@ -59,6 +59,8 @@
 				"Set configuration file"	},
     { 0, 'o',	"one-shot",	"",
 				"Terminate daemon after last link shutdown"	},
+    { 0, 'O',	"delayed-one-shot",	"",
+				"Terminate daemon after last active link shutdown"	},
     { 1, 'p',	"pidfile",	"filename",
 				"Set PID filename"		},
 #ifdef SYSLOG_FACILITY
@@ -119,6 +121,7 @@
   struct globalconf	gGlobalConf;
 
   pthread_mutex_t	gGiantMutex;
+  pthread_mutex_t	gNgMutex;
 
   const char		*gConfigFile = CONF_FILE;
   const char		*gConfDirectory = PATH_CONF_DIR;
@@ -179,6 +182,17 @@
     memcpy(args, av, ac * sizeof(*av));	/* Copy to preserve "ps" output */
     OptParse(ac - 1, args + 1);
 
+    ret = pthread_mutex_init (&gGiantMutex, NULL);
+    if (ret != 0) {
+	Log(LG_ERR, ("Could not create giant mutex %d", ret));
+	exit(EX_UNAVAILABLE);
+    }
+    ret = pthread_mutex_init (&gNgMutex, NULL);
+    if (ret != 0) {
+	Log(LG_ERR, ("Could not create NetGraph mutex %d", ret));
+	exit(EX_UNAVAILABLE);
+    }
+
     /* init console-stuff */
     ConsoleInit(&gConsole);
 
@@ -233,7 +247,8 @@
 #ifdef CCP_MPPC
     MppcTestCap();
 #endif
-    if ((LinksInit() != 0) || (CcpsInit() != 0) || (EcpsInit() != 0))
+    if ((LinksInit() != 0) || (CcpsInit() != 0) || (EcpsInit() != 0) ||
+	(MsgSetup() != 0) || (AuthSetup() != 0))
 	exit(EX_UNAVAILABLE);
     
     /* Init device types. */
@@ -244,12 +259,6 @@
 	}
     }
 
-    ret = pthread_mutex_init (&gGiantMutex, NULL);
-    if (ret != 0) {
-	Log(LG_ERR, ("Could not create giant mutex %d", ret));
-	exit(EX_UNAVAILABLE);
-    }
-
     /* Create signaling pipe */
     if ((ret = pipe(gSignalPipe)) != 0) {
 	Log(LG_ERR, ("Could not create signal pipe %d", ret));
@@ -259,6 +268,7 @@
       EVENT_RECURRING, SignalHandler, NULL) != 0)
 	exit(EX_UNAVAILABLE);
 
+   
     /* Register for some common fatal signals so we can exit cleanly */
     signal(SIGINT, SendSignal);
     signal(SIGTERM, SendSignal);
@@ -367,7 +377,9 @@
     if (code != EX_TERMINATE)	/* kludge to avoid double shutdown */
 	CloseIfaces();
 
+    MUTEX_LOCK(gNgMutex);
     NgFuncShutdownGlobal();
+    MUTEX_UNLOCK(gNgMutex);
 
     /* Blow away all netgraph nodes */
     for (k = 0; k < gNumBundles; k++) {
@@ -529,7 +541,7 @@
 CheckOneShot(void)
 {
     int	i;
-    if (!Enabled(&gGlobalConf.options, GLOBAL_CONF_ONESHOT))
+    if (gShutdownInProgress || !Enabled(&gGlobalConf.options, GLOBAL_CONF_ONESHOT))
 	return;
     for (i = 0; i < gNumLinks; i++) {
 	if (gLinks[i] && !gLinks[i]->tmpl)
@@ -608,6 +620,9 @@
 	case 'o':
 	    Enable(&gGlobalConf.options, GLOBAL_CONF_ONESHOT);
     	    return(0);
+	case 'O':
+	    Enable(&gGlobalConf.options, GLOBAL_CONF_DELAYEDONESHOT);
+    	    return(0);
 	case 'p':
     	    gPidFile = *av;
     	    return(1);
diff -ur mpd-5.6/src/modem.c mpd-5.6-lutz/src/modem.c
--- mpd-5.6/src/modem.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/modem.c	2013-03-28 16:46:04.000000000 +0100
@@ -351,6 +351,7 @@
     TimerStop(&m->checkTimer);
     TimerStop(&m->startTimer);
     TimerStop(&m->reportTimer);
+    MUTEX_LOCK(gNgMutex);
     if (*m->ttynode != '\0') {
 	char	path[NG_PATHSIZ];
 
@@ -365,6 +366,7 @@
 	close(m->csock);
 	m->csock = -1;
     }
+    MUTEX_UNLOCK(gNgMutex);
     ExclusiveCloseDevice(l->name, m->fd, m->device);
     m->lastClosed = time(NULL);
     m->answering = FALSE;
@@ -383,14 +385,17 @@
     ModemInfo	const m = (ModemInfo) l->info;
     char	path[NG_PATHSIZ];
 
+    MUTEX_LOCK(gNgMutex);
     /* Update async config */
     m->acfg.accm = xmit|recv;
     snprintf(path, sizeof(path), "%s:%s", m->ttynode, NG_TTY_HOOK);
     if (NgSendMsg(m->csock, path, NGM_ASYNC_COOKIE,
       NGM_ASYNC_CMD_SET_CONFIG, &m->acfg, sizeof(m->acfg)) < 0) {
 	Perror("[%s] MODEM: can't update config for %s", l->name, path);
+	MUTEX_UNLOCK(gNgMutex);
 	return (-1);
     }
+    MUTEX_UNLOCK(gNgMutex);
     return (0);
 }
 
@@ -527,9 +532,11 @@
     int	tty[2];
 #endif
 
+    MUTEX_LOCK(gNgMutex);
     /* Get a temporary netgraph socket node */
     if (NgMkSockNode(NULL, &m->csock, NULL) < 0) {
 	Perror("[%s] MODEM: NgMkSockNode failed", l->name);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
@@ -548,6 +555,7 @@
 	if (ioctl(m->fd, TIOCSETD, &ldisc) < 0) {
 	    Perror("[%s] ioctl(TIOCSETD, %d)", l->name, ldisc);
 	    close(m->csock);
+	    MUTEX_UNLOCK(gNgMutex);
 	    return(-1);
 	}
     }
@@ -556,6 +564,7 @@
     if (ioctl(m->fd, NGIOCGINFO, &ngtty) < 0) {
 	Perror("[%s] MODEM: ioctl(NGIOCGINFO)", l->name);
 	close(m->csock);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
     strlcpy(m->ttynode, ngtty.name, sizeof(m->ttynode));
@@ -569,6 +578,7 @@
 	Perror("[%s] MODEM: can't connect %s node on %s", l->name,
 	    NG_TTY_NODE_TYPE, ".");
 	close(m->csock);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
     snprintf(path, sizeof(path), ".:%s", NG_TTY_HOOK);
@@ -578,6 +588,7 @@
 	    Perror("[%s] MODEM: can't locate %s node on %s (%d)", l->name,
 	    NG_TTY_NODE_TYPE, path, errno);
 	    close(m->csock);
+	    MUTEX_UNLOCK(gNgMutex);
 	    return(-1);
 	}
     }
@@ -589,6 +600,7 @@
           NGM_TTY_SET_TTY, &tty, sizeof(tty)) < 0) {
 	Perror("[%s] MODEM: can't hook tty to fd %d", l->name, m->fd);
 	close(m->csock);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
     /* Disconnect temporary hook. */
@@ -597,6 +609,7 @@
 	    NGM_GENERIC_COOKIE, NGM_RMHOOK, &rm, sizeof(rm)) < 0) {
 	Perror("[%s] MODEM: can't remove hook %s", l->name, NG_TTY_HOOK);
 	close(m->csock);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 #endif
@@ -607,6 +620,7 @@
       NGM_TTY_SET_HOTCHAR, &hotchar, sizeof(hotchar)) < 0) {
 	Perror("[%s] MODEM: can't set hotchar", l->name);
 	close(m->csock);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
@@ -618,6 +632,7 @@
       NGM_MKPEER, &ngm, sizeof(ngm)) < 0) {
 	Perror("[%s] MODEM: can't connect %s node", l->name, NG_ASYNC_NODE_TYPE);
 	close(m->csock);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
@@ -632,6 +647,7 @@
       NGM_ASYNC_CMD_SET_CONFIG, &m->acfg, sizeof(m->acfg)) < 0) {
 	Perror("[%s] MODEM: can't config %s", l->name, path);
 	close(m->csock);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
@@ -639,6 +655,7 @@
     if (!PhysGetUpperHook(l, cn.path, cn.peerhook)) {
 	Log(LG_PHYS, ("[%s] MODEM: can't get upper hook", l->name));
 	close(m->csock);
+	MUTEX_UNLOCK(gNgMutex);
 	return (-1);
     }
     snprintf(cn.ourhook, sizeof(cn.ourhook), NG_ASYNC_HOOK_SYNC);
@@ -647,9 +664,11 @@
 	Perror("[%s] MODEM: can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\"",
 	    l->name, path, cn.ourhook, cn.path, cn.peerhook);
 	close(m->csock);
+	MUTEX_UNLOCK(gNgMutex);
 	return (-1);
     }
 
+    MUTEX_UNLOCK(gNgMutex);
     return(0);
 }
 
@@ -752,8 +771,10 @@
       || stats.asyncRunts || stats.asyncOverflows)) {
 	Log(LG_PHYS, ("[%s] NEW FRAME ERRS: FCS %u RUNT %u OVFL %u", l->name,
           stats.asyncBadCheckSums, stats.asyncRunts, stats.asyncOverflows));
+	MUTEX_LOCK(gNgMutex);
 	(void) NgSendMsg(m->csock, path,
 	    NGM_ASYNC_COOKIE, NGM_ASYNC_CMD_CLR_STATS, NULL, 0);
+	MUTEX_UNLOCK(gNgMutex);
     }
 
     /* Restart timer */
@@ -775,15 +796,18 @@
 	struct ng_mesg	resp;
     } u;
 
+    MUTEX_LOCK(gNgMutex);
     /* Get stats */
     snprintf(path, sizeof(path), "%s:%s", m->ttynode, NG_TTY_HOOK);
     if (NgFuncSendQuery(path, NGM_ASYNC_COOKIE, NGM_ASYNC_CMD_GET_STATS,
       NULL, 0, &u.resp, sizeof(u), NULL) < 0) {
 	Perror("[%s] MODEM: can't get stats", l->name);
+	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
     memcpy(sp, u.resp.data, sizeof(*sp));
+    MUTEX_UNLOCK(gNgMutex);
     return(0);
 }
 
diff -ur mpd-5.6/src/msg.c mpd-5.6-lutz/src/msg.c
--- mpd-5.6/src/msg.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/msg.c	2013-04-22 00:14:59.000000000 +0200
@@ -16,67 +16,256 @@
 
 /* Which pipe file descriptor is which */
 
-  #define PIPE_READ		0
-  #define PIPE_WRITE		1
-
   struct mpmsg
   {
     int		type;
     void	(*func)(int type, void *arg);
+    void	(*final)(int type, void *arg, int canceled);
     void	*arg;
     const char	*dbg;
+    int		refs;
+    int 	canceled;
+    struct paction *thread;
   };
-  typedef struct mpmsg	*Msg;
-
-  #define	MSG_QUEUE_LEN	8192
-  #define	MSG_QUEUE_MASK	0x1FFF
-
-  struct mpmsg	msgqueue[MSG_QUEUE_LEN];
-  int		msgqueueh = 0;
-  int		msgqueuet = 0;
-  #define	QUEUELEN()	((msgqueueh >= msgqueuet)?	\
-	(msgqueueh - msgqueuet):(msgqueueh + MSG_QUEUE_LEN - msgqueuet))
-
-  int           msgpipe[2];
-  int		msgpipesent = 0;
-  EventRef	msgevent;
 
 /*
  * INTERNAL FUNCTIONS
  */
 
-  static void	MsgEvent(int type, void *cookie);
+  static void	SerialAction(void *arg);
+  static void	SerialDied(void *arg, int canceled);
+  static void	ParallelAction(void *arg);
+  static void	ParallelDied(void *arg, int canceled);
+
+  static struct queue_data {
+     struct mesg_port * port;
+     struct paction * dispatcher;
+     void (*action)(void * arg);
+     void (*terminate)(void * arg, int canceled);
+     int max_workers;
+     struct mesg_port * worker_port;
+     struct worker_data {
+	Msg msg;
+	struct queue_data * queue;
+     } *workers;	  
+  } queue[] = {
+     { .action = SerialAction  , .terminate = SerialDied   , .max_workers = 0 },
+     { .action = ParallelAction, .terminate = ParallelDied , .max_workers = 8 },
+  };
+
+  static void	ParallelWorker(void *arg);
+  static void	ParallelWorkerDied(void *arg, int canceled);
+  static int	ReuseWorker(struct worker_data * worker);
+
+  int		gQueueDelay = 20;
+
+static void
+update_overload(void) {
+   int i,o=0;
+   time_t now;
+   static time_t last_reported = 0;
+   static int peak[2] = {0};
+   
+   time(&now);
+   
+   for(i=0; i<sizeof(queue)/sizeof(*queue); i++)
+     if(queue[i].port) {
+	int l = mesg_port_qlen(queue[i].port);
+	o += l * (2 + queue[i].max_workers);
+	if(peak[i] < l)
+	  peak[i] = l;
+     }
+   
+   SETOVERLOAD(o);
+   if(now > last_reported) {
+      Log(LG_ALWAYS, ("Queues had up to %d (serial) and %d (parallel) entries.",
+		      peak[0], peak[1]));
+      peak[0] = 0;
+      peak[1] = 0;
+      last_reported = now + (60 - 1);  /* 1 second due to strict less then */
+   }
+   
+}
+
+
+int
+MsgSetup(void)
+{
+   int i;
+   for(i=0; i<sizeof(queue)/sizeof(*queue); i++) {
+      if(NULL == (queue[i].port = mesg_port_create(MB_MP))) {
+	 Perror("%s: mesg_port_create failed with %s",
+		__FUNCTION__, strerror(errno));
+	 return(-1);
+      }
+      if (paction_start(&queue[i].dispatcher, &gGiantMutex,
+			queue[i].action, queue[i].terminate,
+			&queue[i]) == -1) {
+	 Perror("%s: error paction_start: %s", __FUNCTION__, strerror(errno));
+	 return(-1);
+      }
+      if(queue[i].max_workers > 0) {
+	 int j;
+	 
+	 if(NULL == (queue[i].worker_port = mesg_port_create(MB_MP))) {
+	    Perror("%s: mesg_port_create failed with %s",
+		   __FUNCTION__, strerror(errno));
+	    return(-1);
+	 }
+	 
+	 queue[i].workers = Malloc(MB_MP, queue[i].max_workers * sizeof(*queue[i].workers));
+	 assert(queue[i].workers);
+	 
+	 for(j=0; j<queue[i].max_workers; j++) {
+	    queue[i].workers[j].queue = &queue[i];
+	    if(-1 == ReuseWorker(&(queue[i].workers[j]))) {
+	       return(-1);
+	    }
+	 }
+      }
+   }
+   
+   return 0;
+}
+
+int
+ReuseWorker(struct worker_data * worker)
+{
+   assert(worker);
+   assert(worker->queue);
+   assert(worker->queue->worker_port);
+   
+   RESETREF(worker->msg, NULL);
+   
+   if(-1 == mesg_port_put(worker->queue->worker_port, worker)) {
+      Perror("%s: mesg_port_put failed with %s",
+	     __FUNCTION__, strerror(errno));
+      return -1;
+   }
+   
+   return 0;
+}
+
+void
+SerialAction(void *arg) 
+{
+   struct queue_data * q = arg;
+   
+   while(1) {
+      Msg msg = mesg_port_get(q->port, -1);
+      assert(msg);
+      GIANT_MUTEX_LOCK();
+      if(!msg->canceled) {
+	 Log(LG_EVENTS, ("EVENT: Serial processing msg %d to %s", msg->type, msg->dbg));
+	 (*msg->func)(msg->type, msg->arg);
+	 Log(LG_EVENTS, ("EVENT: Serial processing msg %d to %s done", msg->type, msg->dbg));
+      }
+      RESETREF(msg, NULL);
+      update_overload();
+      GIANT_MUTEX_UNLOCK();
+      usleep(gQueueDelay * 1000);
+   }
+}
+
+void
+SerialDied(void *arg, int canceled)
+{
+   Perror("%s: Dispatcher %s unexpectedly. Stop processing.",
+	  __FUNCTION__, (canceled ? "was canceled" : "died"));
+}
+
+
+void
+ParallelWorker(void *arg)
+{
+   struct worker_data * worker = arg;
+   Msg msg;
+   
+   assert(worker);
+   assert(worker->msg);
+   
+   msg = worker->msg;
+
+   Log(LG_EVENTS, ("EVENT: Parallel processing msg %d to %s", msg->type, msg->dbg));
+   assert(msg->func);
+   (*msg->func)(msg->type, msg->arg);
+   Log(LG_EVENTS, ("EVENT: Parallel processing msg %d to %s done", msg->type, msg->dbg));
+}
+
+void
+ParallelWorkerDied(void *arg, int canceled)
+{
+   struct worker_data * worker = arg;
+   Msg msg;
+   
+   assert(worker);
+   assert(worker->msg);
+   
+   msg = worker->msg;
+
+   if(msg->final) {
+      Log(LG_EVENTS, ("EVENT: Cleanup processing msg %d to %s with %d", msg->type, msg->dbg, canceled));
+      (*msg->final)(msg->type, msg->arg, canceled);
+      Log(LG_EVENTS, ("EVENT: Cleanup processing msg %d to %s with %d done", msg->type, msg->dbg, canceled));
+   } else {
+      Log(LG_EVENTS, ("EVENT: Skipping cleanup processing msg %d to %s with %d", msg->type, msg->dbg, canceled));
+   }
+   
+   ReuseWorker(worker);
+}
+
+void
+ParallelAction(void *arg)
+{
+   struct queue_data * q = arg;
+   
+   while(1) {
+      Msg msg = mesg_port_get(q->port, -1);
+      struct worker_data * worker = mesg_port_get(q->worker_port, -1);
+      
+      assert(msg);
+      assert(worker);
+      assert(worker->queue);
+      
+      REF(msg);
+      worker->msg = msg;
+      
+      if(!msg->canceled) {
+	 if(-1 == paction_start(&(msg->thread), &gGiantMutex,
+				ParallelWorker, ParallelWorkerDied, worker)) {
+	    Perror("%s: paction_start failed with %s\n", __FUNCTION__, strerror(errno));
+	    ReuseWorker(worker);
+	 }
+      } else {
+	 ParallelWorkerDied(worker, 1);
+      }
+      
+      RESETREF(msg, NULL);
+      update_overload();
+   }
+}
+
+void
+ParallelDied(void *arg, int canceled)
+{
+   Perror("%s: Dispatcher %s unexpectedly. Stop processing.",
+	  __FUNCTION__, (canceled ? "was canceled" : "died"));
+}
+
+
 
 /*
  * MsgRegister()
  */
 
 void
-MsgRegister2(MsgHandler *m, void (*func)(int type, void *arg), const char *dbg)
+MsgRegister2(MsgHandler *m, void (*func)(int type, void *arg), void(*final)(int typ, void *arg, int was_canceled), const char *dbg, enum msghandlermodel model)
 {
-    if ((msgpipe[0]==0) || (msgpipe[1]==0)) {
-	if (pipe(msgpipe) < 0) {
-	    Perror("%s: Can't create message pipe", 
-		__FUNCTION__);
-	    DoExit(EX_ERRDEAD);
-	}
-	fcntl(msgpipe[PIPE_READ], F_SETFD, 1);
-	fcntl(msgpipe[PIPE_WRITE], F_SETFD, 1);
-
-	if (fcntl(msgpipe[PIPE_READ], F_SETFL, O_NONBLOCK) < 0)
-    	    Perror("%s: fcntl", __FUNCTION__);
-	if (fcntl(msgpipe[PIPE_WRITE], F_SETFL, O_NONBLOCK) < 0)
-    	    Perror("%s: fcntl", __FUNCTION__);
-
-	if (EventRegister(&msgevent, EVENT_READ,
-		msgpipe[PIPE_READ], EVENT_RECURRING, MsgEvent, NULL) < 0) {
-	    Perror("%s: Can't register event", __FUNCTION__);
-	    DoExit(EX_ERRDEAD);
-        }
-    }
-
+    assert(m);
     m->func = func;
+    m->final = final;
     m->dbg = dbg;
+    m->model = model;
 }
 
 /*
@@ -86,63 +275,73 @@
 void
 MsgUnRegister(MsgHandler *m)
 {
+    assert(m);
     m->func = NULL;
+    m->final = NULL;
     m->dbg = NULL;
+    m->model = -1;
 }
 
 /*
- * MsgEvent()
+ * MsgSend()
  */
 
-static void
-MsgEvent(int type, void *cookie)
+void
+MsgAsyncSend(Msg *mc, MsgHandler *m, int type, void *arg)
 {
-    char	buf[16];
-    /* flush signaling pipe */
-    msgpipesent = 0;
-    while (read(msgpipe[PIPE_READ], buf, sizeof(buf)) == sizeof(buf));
-
-    while (msgqueuet != msgqueueh) {
-	Log(LG_EVENTS, ("EVENT: Message %d to %s received",
-	    msgqueue[msgqueuet].type, msgqueue[msgqueuet].dbg));
-	(*(msgqueue[msgqueuet].func))(msgqueue[msgqueuet].type, msgqueue[msgqueuet].arg);
-	Log(LG_EVENTS, ("EVENT: Message %d to %s processed",
-	    msgqueue[msgqueuet].type, msgqueue[msgqueuet].dbg));
-
-	msgqueuet = (msgqueuet + 1) & MSG_QUEUE_MASK;
-	SETOVERLOAD(QUEUELEN());
-    }
-}
+   Msg msg;
 
-/*
- * MsgSend()
- */
+   assert(m);
+   assert(m->func);
+   assert(m->model >= 0 && m->model <= 1);
+   
+   if(mc != NULL)
+     *mc  = NULL;
+   
+   msg = Malloc(MB_MP, sizeof(*msg));
+   assert(msg);
+   msg->type = type;
+   msg->arg = arg;
+   msg->func = m->func;
+   msg->final = m->final;
+   msg->dbg = m->dbg;
+   REF(msg);			       /* my copy */
+   
+   REF(msg);			       /* send msg */
+   if(-1 == mesg_port_put(queue[m->model].port, msg)) {
+      Perror("%s: mesg_port_put failed with %s",
+	     __FUNCTION__, strerror(errno));
+      UNREF(msg);		       /* msg was not send */
+   } else {
+      Log(LG_EVENTS, ("EVENT: Message %d to %s sent", type, m->dbg));
+      if(mc != NULL) {
+	 REF(msg);		       /* hand out a other copy */
+	 *mc = msg;
+      }
+   }
+   RESETREF(msg, NULL);		       /* destroy my copy */
+}
 
 void
-MsgSend(MsgHandler *m, int type, void *arg)
+MsgAsyncCancel(Msg *mc)
 {
-    assert(m);
-    assert(m->func);
+   assert(mc);
+   if(*mc) {
+      Msg msg = *mc;
+      Log(LG_EVENTS, ("EVENT: Canceling msg %d to %s", msg->type, msg->dbg));
+      msg->canceled = 1;
+      paction_cancel(&(msg->thread));
+   }
+   MsgFree(mc);
+}
 
-    msgqueue[msgqueueh].type = type;
-    msgqueue[msgqueueh].func = m->func;
-    msgqueue[msgqueueh].arg = arg;
-    msgqueue[msgqueueh].dbg = m->dbg;
-
-    msgqueueh = (msgqueueh + 1) & MSG_QUEUE_MASK;
-    if (msgqueuet == msgqueueh) {
-        Log(LG_ERR, ("%s: Fatal message queue overflow!", __FUNCTION__));
-        DoExit(EX_ERRDEAD);
-    }
-
-    SETOVERLOAD(QUEUELEN());
-
-    if (!msgpipesent) {
-	char	buf[1] = { 0x2a };
-	if (write(msgpipe[PIPE_WRITE], buf, 1) > 0)
-	    msgpipesent = 1;
-    }
-    Log(LG_EVENTS, ("EVENT: Message %d to %s sent", type, m->dbg));
+void
+MsgFree(Msg *mc)
+{
+   assert(mc);
+   if(*mc) {
+      RESETREF(*mc, NULL);
+   }
 }
 
 /*
diff -ur mpd-5.6/src/msg.h mpd-5.6-lutz/src/msg.h
--- mpd-5.6/src/msg.h	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/msg.h	2013-02-04 23:17:47.000000000 +0100
@@ -27,20 +27,31 @@
   struct msghandler
   {
     void	(*func)(int type, void *arg);
+    void 	(*final)(int typ, void *arg, int was_canceled);
     const char	*dbg;
+    enum msghandlermodel { MsgSerial = 0, MsgParallel = 1 } model;
   };
-
   typedef struct msghandler	MsgHandler;
 
+  typedef struct mpmsg	*	Msg;
+   
+
 /*
  * FUNCTIONS
  */
 
-#define	MsgRegister(m, func)	\
-	    MsgRegister2(m, func, #func "()")
-  extern void		MsgRegister2(MsgHandler *m, void (*func)(int typ, void *arg), const char *dbg);
+#define	MsgSerialRegister(m, func)	\
+	    MsgRegister2(m, func, NULL, #func "()", MsgSerial)
+#define	MsgParallelRegister(m, func, final)	\
+	    MsgRegister2(m, func, final, #func "()", MsgParallel)
+  extern int		MsgSetup(void);
+  extern void		MsgRegister2(MsgHandler *m, void (*func)(int typ, void *arg), void(*final)(int typ, void *arg, int was_canceled), const char *dbg, enum msghandlermodel model);
   extern void		MsgUnRegister(MsgHandler *m);
-  extern void		MsgSend(MsgHandler *m, int type, void *arg);
+#define MsgSend(m, type, arg)	\
+   	    MsgAsyncSend(NULL, m, type, arg);
+  extern void		MsgAsyncSend(Msg *mc, MsgHandler *m, int type, void *arg);
+  extern void		MsgAsyncCancel(Msg *mc);
+  extern void		MsgFree(Msg *mc);
   extern const char	*MsgName(int msg);
 
 #endif
diff -ur mpd-5.6/src/ng.c mpd-5.6-lutz/src/ng.c
--- mpd-5.6/src/ng.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/ng.c	2013-04-24 12:02:18.000000000 +0200
@@ -111,7 +111,7 @@
     struct ngm_connect	cn;
 
     if (!PhysGetUpperHook(l, path, cn.ourhook)) {
-        Log(LG_PHYS, ("[%s] NG: can't get upper hook", l->name));
+        Log(LG_ERR|LG_PHYS, ("[%s] NG: can't get upper hook", l->name));
 	goto fail;
     }
     
diff -ur mpd-5.6/src/phys.c mpd-5.6-lutz/src/phys.c
--- mpd-5.6/src/phys.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/phys.c	2013-02-04 22:54:06.000000000 +0100
@@ -67,7 +67,7 @@
 int
 PhysInit(Link l)
 {
-    MsgRegister(&l->pmsgs, PhysMsg);
+    MsgSerialRegister(&l->pmsgs, PhysMsg);
 
     /* Initialize type specific stuff */
     if ((l->type->init)(l) < 0) {
@@ -475,7 +475,7 @@
 PhysIsBusy(Link l)
 {
     return (l->die || l->rep || l->state != PHYS_STATE_DOWN ||
-	l->lcp.fsm.state != ST_INITIAL || l->lcp.auth.acct_thread != NULL ||
+	l->lcp.fsm.state != ST_INITIAL || l->lcp.auth.acct_msg != NULL ||
 	(l->tmpl && (l->children >= l->conf.max_children || gChildren >= gMaxChildren)));
 }
 
diff -ur mpd-5.6/src/ppp.h mpd-5.6-lutz/src/ppp.h
--- mpd-5.6/src/ppp.h	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/ppp.h	2013-04-22 00:12:25.000000000 +0200
@@ -46,6 +46,7 @@
 #include "contrib/libpdel/util/pevent.h"
 #include "contrib/libpdel/util/paction.h"
 #include "contrib/libpdel/util/ghash.h"
+#include "contrib/libpdel/util/mesg_port.h"
 #else
 #include <pdel/structs/structs.h>
 #include <pdel/structs/type/array.h>
@@ -53,6 +54,7 @@
 #include <pdel/util/pevent.h>
 #include <pdel/util/paction.h>
 #include <pdel/util/ghash.h>
+#include <pdel/util/mesg_port.h>
 #endif
 
 #include <netgraph/ng_message.h>
@@ -193,6 +195,7 @@
   extern int		gBackground;
   extern int		gShutdownInProgress;
   extern int		gOverload;
+  extern int		gQueueDelay;
   extern pid_t		gPid;
   extern int		gRouteSeq;
 
@@ -215,6 +218,7 @@
 
   extern struct pevent_ctx	*gPeventCtx;
   extern pthread_mutex_t	gGiantMutex;	/* Giant Mutex */
+  extern pthread_mutex_t	gNgMutex;	/* NetGraph Mutex */
 
   extern const char	*gVersion;		/* Program version string */
   extern const char	*gConfigFile;		/* Main config file */
